import sys
#qt
from PyQt5.QtWidgets import QWidget, QShortcut, QDesktopWidget, QApplication, QLabel, QTableWidget, QTableWidgetItem, QTableView, QLineEdit, QVBoxLayout
from PyQt5.QtWidgets import QMainWindow, QAbstractItemView
from PyQt5.QtCore import pyqtSlot, Qt, QAbstractTableModel, QObject
from PyQt5.QtGui import QKeySequence, QMovie, QImage, QPixmap, QFont, QPixmap, QIcon
#read
import json
#fuck
from PIL import Image 
import tempfile
#open programs
import subprocess
#somehow the best way to open a folder
import webbrowser
    
#self.columns = ['Icon', 'Prefix', 'Creator', 'Name', 'Tags']
ICON    = 0
PREFIX  = 1
CREATOR = 2
NAME    = 3
TAGS    = 4
NUMCOL  = 5
#following columns aren't displayed
ID      = 5
IMG     = 6
EXE     = 7
TOTCOL  = 8


class TableModel(QAbstractTableModel):
    def __init__(self):
        QAbstractTableModel.__init__(self)
        self._data = []
        #virtual rows for searches
        self.vRows = []
        self.rows = 0
        #bold font
        self.bold = QFont()
        self.bold.setBold(True)
        self.columns = ['Icon', 'Prefix', 'Creator', 'Name', 'Tags']
        self.term = ""
        self.dir = tempfile.TemporaryDirectory()
        self.images = []
                
    def rowCount(self, index):
            return self.rows
            
    def columnCount(self, index):
            #creator | name | RJ
            return NUMCOL
            
    def data(self, index, role):
        #return data from virtual row
        if role == Qt.DisplayRole and index.column() != ICON:
            out = self._data[index.row()][index.column()]
            #format lists
            if(isinstance(out,list)):
                if len(out) >= 1:
                    outStr = ""
                    for o in out[:-1]:
                        outStr += str(o) + ', '
                    outStr += out[-1]
                    return outStr
                else:
                    return ""
            return out
        #change creator column to bold
        if role == Qt.FontRole and index.column() == CREATOR:
            return self.bold
        #icons
        if role == Qt.DecorationRole and index.column() == ICON:
            return self._data[index.row()][index.column()]
            
    def headerData(self, section, orientation, role):
        if role == Qt.DisplayRole and orientation == Qt.Horizontal:
            return self.columns[section]
        return QAbstractTableModel.headerData(self, section, orientation, role)
            
    def sort(self, col, reverse):
        if col == ICON:
            return
        try:
            self.layoutAboutToBeChanged.emit()
            #Sort by column COL
            self._data.sort(key= lambda x : x[col] if isinstance(x[col], str) else "", reverse=(reverse==0))
            self.search(self.term)
        except Exception as e:
            print(e)
            
    def getBackground(self, row):
        imgFile = self._data[row][IMG]
        if imgFile == []:
            return "none"
        #fucking atrocious, but it's somehow the easiest way to display a background image with lower opacity with this piece of shit library
        elif(self.images[row] == None):
                img = Image.open(imgFile)
                img.putalpha(100)
                #ext = imgFile.split('.')[-1]
                ext = 'png'
                path = self.dir.name+'\\'+str(row)+'.' + ext
                img.save(path)
                print("saved background" + path)
                self.images[row] = path.replace("\\", "/")
        return "url(" + self.images[row] + ");"# 0 0 0 0 cover cover;"
        
    def search(self, term):
        term = term.lower()
        self.layoutAboutToBeChanged.emit()
        self.term = term
        if len(term) == 0:
            #search term empty, reset virtual rows
            self.rows = len(self._data)
            self.vRows = list(range(len(self._data)))
        else:
            #empty virtual rows, add back all that have a column matching term, then change the number of rows
            self.vRows = []
            for r in range(len(self._data)):
                add = False
                #skip icon
                for c in range(1,len(self._data[r])):
                    if isinstance(self._data[r][c], str):
                        if term in self._data[r][c].lower():
                            add = True
                            break
                    else:
                        for d in self._data[r][c]:
                            if term in d.lower():                            
                                add = True
                                break
                if add:
                    self.vRows += [r]
            self.rows = len(self.vRows)
        self.layoutChanged.emit()

    def loadData(self, filename):
        self.layoutAboutToBeChanged.emit()        
        with open('g.json', 'r') as file:
            jDict = json.load(file)
        for id in jDict:
            game = [[]] * TOTCOL
            game[ID] = id
            try:
                game[ICON] = QPixmap('./img/'+id+'/icon.bmp')
            except:
                game[ICON] = []
            game[PREFIX] = jDict[id]['prefix']
            game[CREATOR] = jDict[id]['creator']
            game[NAME] = jDict[id]['name']
            game[TAGS] = jDict[id]['tags']
            game[IMG] = jDict[id]['img']
            game[EXE] = jDict[id]['exe']
            self._data += [game]
            self.rows = len(self._data)
            self.images = [None]*self.rows
            self.vRows = list(range(len(self._data)))
        self.layoutChanged.emit()

    def run(self, row):
        path, exe = self._data[self.vRows[row]][EXE].rsplit('\\',1)
        subprocess.Popen(exe.split(' '), shell=True, cwd=path)
        
    def openFolder(self, row):
        path = self._data[self.vRows[row]][EXE].rsplit('\\',1)[0]+'\\'
        webbrowser.open(path)
        
    def copy(self, r, c):
        #ignore icon
        if(c > 0):
            d = self._data[r][c]
            #only take first item if list only has one object 
            if(len(d) == 1):
                s = str(d[0])
            else: 
                s = str(d)
            clipboard.setText(s)
        
#necessary to get a right click the god damn table
class Table(QTableView):
    def mousePressEvent(self, event):
        super().mousePressEvent(event)
        
        if event.button() == Qt.RightButton:
            selected = self.selectionModel().currentIndex()
            self.model().copy(selected.row(), selected.column())
            print('right')
            
        elif event.button() == Qt.MiddleButton:
            selected = self.selectionModel().currentIndex()
            self.model().openFolder(selected.row())
            print('mid')
        

class Window(QWidget):
    def __init__(self, *args, **kwargs):
        QWidget.__init__(self, *args, **kwargs)
        
        self.setWindowTitle('Vidya SEXplorer')
        self.setWindowIcon(QIcon('ic'))
        self.centralize()
        
        self.table = Table()
        self.model = TableModel()
        self.model.loadData('g.txt')
        self.table.setModel(self.model)
        self.table.setSortingEnabled(True)
        
        self.table.selectionModel().currentRowChanged.connect(self.changeBackground)
        self.table.doubleClicked.connect(self.run)
        self.table.setSelectionBehavior(QAbstractItemView.SelectRows)
        
        self.search = QLineEdit()
        self.search.setAlignment(Qt.AlignLeft)
        self.search.textEdited.connect(self.textEdited)
        
        #QShortcut(QKeySequence("r"), self).activated.connect(self.addRegexDiag)
        
        vBox = QVBoxLayout()
        vBox.addWidget(self.search)
        vBox.addWidget(self.table)
        self.setLayout(vBox)
        self.show()
        
    def test(self, index):
        print(index)
    
    def changeBackground(self, item):
        print(self.table)
        self.table.setStyleSheet("border-image: {};".format(self.model.getBackground(item.row())))
        #lmao
        self.table.horizontalHeader().setStyleSheet("border-image: none")
        self.table.verticalHeader().setStyleSheet("border-image: none")
    
    def textEdited(self, item):
        self.model.search(item)
    
    def run(self, item):
        self.model.run(item.row())
    
    @pyqtSlot()
    def centralize(self):
        centralizedRect = self.frameGeometry()
        centralizedRect.moveCenter(QDesktopWidget().availableGeometry().center())
        self.move(centralizedRect.topLeft())
        
    @pyqtSlot()
    def exit(self):
        app.quit()

if __name__ == '__main__':
    app = QApplication([])
    clipboard = app.clipboard()
    window = Window()
    sys.exit(app.exec_())